'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapAuthenticating = exports.fetchWithSilentAuthenticateAndRetryOn401 = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _recompose = require('recompose');

var _reactOidcRedux = require('@axa-fr/react-oidc-redux');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fetchWithSilentAuthenticateAndRetryOn401 = exports.fetchWithSilentAuthenticateAndRetryOn401 = function fetchWithSilentAuthenticateAndRetryOn401(trySilentAuthenticateInjected) {
  return function (fetch) {
    return function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(url) {
        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { method: 'GET' };
        var isRetry = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var response;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return fetch(url, options);

              case 2:
                response = _context.sent;

                if (!isRetry) {
                  _context.next = 8;
                  break;
                }

                if (!(response.status === 401)) {
                  _context.next = 8;
                  break;
                }

                _context.next = 7;
                return trySilentAuthenticateInjected();

              case 7:
                return _context.abrupt('return', fetchWithSilentAuthenticateAndRetryOn401(trySilentAuthenticateInjected)(fetch)(url, options, false));

              case 8:
                return _context.abrupt('return', response);

              case 9:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();
  };
};

var wrapAuthenticating = exports.wrapAuthenticating = function wrapAuthenticating(fetchWithSilentAuthenticateAndRetryOn401Injected) {
  return function () {
    var fetch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
    return function (props) {
      var previousFetch = fetch || props.fetch;
      var newFetch = fetchWithSilentAuthenticateAndRetryOn401Injected(previousFetch);
      var newProps = {
        fetch: newFetch
      };
      return newProps;
    };
  };
};

var enhance = function enhance() {
  var fetch = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : undefined;
  return (0, _recompose.compose)((0, _recompose.withProps)(wrapAuthenticating(fetchWithSilentAuthenticateAndRetryOn401((0, _reactOidcRedux.signinSilent)(_reactOidcRedux.getUserManager)))(fetch)));
};

exports.default = enhance;
//# sourceMappingURL=withFetchSilentAuthenticateAndRetryOn401.js.map